#define ATTR_LONG_NAME		0x0F
#define ATTR_READ_ONLY		0x01
#define ATTR_HIDDEN			0x02
#define ATTR_SYSTEM			0x04
#define ATTR_VOLUME_ID		0x08
#define ATTR_DIRECTORY		0x10
#define ATTR_ARCHIVE		0x20

typedef struct 
{
	unsigned char		name[12];      		//8 chars filename
	unsigned char		attribute;     		//file attributes RSHA, Longname, Drive Label, Directory
	//unsigned char		NT;        			//set to zero
	//unsigned char		erste_msec; 		//creation time part in milliseconds
	//unsigned int		erste_zeit;     	//creation time
	//unsigned int		erstes_datum;   	//creation date
	//unsigned int		letzter_zugriff;	//last access date
	//unsigned int		cluster_high;  		//first cluster high word                 
	//unsigned int		letzte_zeit;    	//last write time
	//unsigned int		letztes_datum;  	//last write date
	unsigned int		erster_cluster; 	//first cluster low word                 
	unsigned long		groesse;     
}VERZEINTRAG;


typedef struct
{
	//MBR
	unsigned long erster_sector;				// Abstand zwischen MBR und dem ersten Sektor der Partition (VBR)
	//unsigned long anzahl_sektoren;	// Anzahl der Sektoren in der Partition
	//unsigned char typ;				// 0x01=FAT12	0x04=FAT16<32MB	0x06=FAT16>32MB	0x0b=FAT32		
	
	//VBR
	unsigned int  bytes_pro_sector;					// Bytes pro Sector auf der Festplatte
	unsigned char sectoren_pro_cluster;				// Sectoren pro Cluster
	unsigned int  reservierte_sectoren;				// Anzahl der reservierten Sectoren
	unsigned char kopien_der_fat;					// normalerweise 2
	unsigned int  max_eintraege_hauptverzeichnis;	// 512 bei FAT16
	unsigned int  sectoren_pro_partition_klein;		// in kleinen Partitionen
	//unsigned char plattentyp;						// F8 Festplatte, F0 Diskette
	unsigned int  sectoren_pro_fat;					// Sectoren pro Fat
	//unsigned int  sectoren_pro_track;				// Sectoren pro Track
	//unsigned int  anzahl_der_koepfe;				// Anzagl der Koepfe
	unsigned long reservierte_sectoren_anfang;		// Reservierte Sectoren am Anfang der Platte
	unsigned long sectoren_in_partition;			// Gesamtzahl der Sectoren in der Partition
	//unsigned int  laufwerknummer;					// erste Platte 0x80, zweite 0x81 usw
	//unsigned char erweiterte_signatur;			// 0x29
	//unsigned long seriennummer;					// Seriennummer des Datentraegers
	//unsigned char datentreagername[11];			// Laufwerk Name
	//unsigned char fatname[8];						// FAT-Name (FAT16)
	//unsigned int  signatur;						// 0x55AA
	
	unsigned long start_fat;                // mbr_partition_anfang + vbr_reservierte_sectoren
	unsigned long start_verz_eintraege;		// fat_start_fat + vbr_sectoren_pro_fat * vbr_kopien_der_fat
	unsigned long start_daten;				// fat_start_verz_eintraege + 32 (vbr_max_eintraege_hauptverzeichnis * 32 /512)
	
	
}PARTITION;


typedef struct
{
	PARTITION   * part;
	VERZEINTRAG eintrag;
	VERZEINTRAG verzeichnis;
	//unsigned long groesse;				// wird in filefind geschrieben
	unsigned long zeichen_pos_in_datei;		// die Zeichennummer in der ganzen Datei
	//unsigned int  start_cluster;			// der erste Cluster
	unsigned int  aktueller_cluster;		// der aktuelle Cluster
	unsigned long sector;					// die Nummer des aktuellen Sectors auf der Platte

	unsigned int  zeichen_pos_im_sector;	// die Zeichennummer im aktuellen Sector
	unsigned int  sector_im_cluster;		// Sektornummer im aktuellen Cluster
	unsigned int  cluster_vom_file;			// der wievielte cluster von der Datei
}DATEI;


void init_DOS(void);

void read_MBR(PARTITION * part,unsigned int offset);

void read_VBR(PARTITION * part);

unsigned int find_next_cluster(PARTITION * part, unsigned int alter_cluster);

PARTITION* getpartition(unsigned char *filepfad);

unsigned long fread_doubleword(DATEI * datei);

unsigned int fread_word(DATEI * datei);

unsigned int fopen(DATEI * datei, unsigned char *filename);

unsigned int fgetc(DATEI * datei);

unsigned int  file_find(DATEI * datei, unsigned char *filename);

void dir(void);

void cd(unsigned char *ladename);

void makerealname(unsigned char * altername,unsigned char * neuername);

void strtoupper(unsigned char * zeiger);

void loadtxt(unsigned char *ladename);
void loadbmp(unsigned int x1, unsigned int y1, unsigned char *ladename);
// liest 16Bit-Wert aus dem Buffer
unsigned int sector_getword(unsigned int offset);

//liest 32Bit-Wert aus dem Buffer
unsigned long sector_getdoubleword(unsigned int offset);

void hexmon(unsigned long nummer);


unsigned int find_free_FAT(DATEI * datei, unsigned char *filename);

unsigned int fwrite(unsigned char *filename);

unsigned int find_free_cluster(PARTITION * part, unsigned int alter_cluster);













